package com.yunzhi.marketing.borker.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 经纪人佣金流水
 * </p>
 *
 * @author yansen
 * @since 2022-07-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="BkAccountRecord对象", description="经纪人佣金流水")
public class BkAccountRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "流水ID")
    @TableId(value = "rec_id", type = IdType.INPUT)
    private String recId;

    @ApiModelProperty(value = "报备ID")
    private String channelCustomerId;

    @ApiModelProperty(value = "人员ID")
    private String personId;

    @ApiModelProperty(value = "楼盘ID")
    private String buildingId;

    @ApiModelProperty(value = "楼盘名称")
    private String buildingName;

    @ApiModelProperty(value = "佣金;单位分")
    private Integer charges;

    @ApiModelProperty(value = "收支类型;1收,-1支")
    private Integer chargeType;

    @ApiModelProperty(value = "费用说明;到访,签约等")
    private String chargeDesc;

    @ApiModelProperty(value = "费用代码")
    private String chargeCode;

    @ApiModelProperty(value = "状态")
    private Integer status;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createDate;


}
