package com.yunzhi.marketing.borker.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.yunzhi.marketing.borker.entity.BkAgreement;
import com.yunzhi.marketing.borker.mapper.BkAgreementMapper;
import com.yunzhi.marketing.borker.service.IBkAgreementService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yunzhi.marketing.common.CommConstant;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 佣金规则 服务实现类
 * </p>
 *
 * @author yansen
 * @since 2022-07-26
 */
@Service
public class BkAgreementServiceImpl extends ServiceImpl<BkAgreementMapper, BkAgreement> implements IBkAgreementService {

    @Override
    public boolean switchByBuilding(String buildingId, Boolean on) {
        UpdateWrapper<BkAgreement> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("building_id", buildingId);
        updateWrapper.gt("status", CommConstant.STATUS_DELETE);
        updateWrapper.set("status", on ? CommConstant.STATUS_NORMAL : CommConstant.STATUS_READY);

        return update(updateWrapper);
    }

    @Override
    public BkAgreement getByBuilding(String buildingId) {
        QueryWrapper<BkAgreement> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("building_id", buildingId);
        queryWrapper.gt("status", CommConstant.STATUS_DELETE);
        queryWrapper.last("limit 1");

        return getOne(queryWrapper);
    }
}
