package com.yunzhi.marketing.borker.service.impl;

import com.yunzhi.marketing.borker.entity.BkBankCard;
import com.yunzhi.marketing.borker.mapper.BkBankCardMapper;
import com.yunzhi.marketing.borker.service.IBkBankCardService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yunzhi.marketing.common.CommConstant;
import com.yunzhi.marketing.common.DateUtils;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

/**
 * <p>
 * 经纪人银行卡信息 服务实现类
 * </p>
 *
 * @author yansen
 * @since 2022-07-26
 */
@Service
public class BkBankCardServiceImpl extends ServiceImpl<BkBankCardMapper, BkBankCard> implements IBkBankCardService {

    @Override
    public List<BkBankCard> getListByBorker(String personId) {
        return baseMapper.getListByBorker(personId);
    }

    @Override
    public boolean mergeList(String personId, List<BkBankCard> bankCardList) {
        // 先删除已有的
        removeByMap(new HashMap<String, Object>(){{
            put("person_id", personId);
        }});

        // 挨个处理下
        for (BkBankCard item : bankCardList) {
            item.setPersonId(personId);
            if (null == item.getStatus()) {
                item.setStatus(CommConstant.STATUS_NORMAL);
            }
            if (null == item.getCreateDate()) {
                item.setCreateDate(DateUtils.now());
            }
        }

        // 再插入新的
        return saveBatch(bankCardList);
    }
}
