package com.yunzhi.marketing.controller;


import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.yunzhi.marketing.base.BaseController;
import com.yunzhi.marketing.base.ResponseBean;
import com.yunzhi.marketing.borker.service.IBkAgreementService;
import com.yunzhi.marketing.common.CommConstant;
import com.yunzhi.marketing.common.StringUtils;
import com.yunzhi.marketing.entity.*;
import com.yunzhi.marketing.mapper.TaBuildingApartmentMapper;
import com.yunzhi.marketing.mapper.TaBuildingMapper;
import com.yunzhi.marketing.mapper.TaOrgMapper;
import com.yunzhi.marketing.reportCustomerAop.ReportCustomer;
import com.yunzhi.marketing.service.ITaBuildingService;
import com.yunzhi.marketing.service.ITaPersonBuildingService;
import com.yunzhi.marketing.service.ITaPersonService;
import com.yunzhi.marketing.service.ITaSaveService;
import com.yunzhi.marketing.xlk.service.ISceneLogService;
import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 项目表 前端控制器
 * </p>
 *
 * @author jobob
 * @since 2019-05-10
 */
@RestController
@RequestMapping("/api")
@Api(value = "xlk-楼盘", tags = "xlk-楼盘")
public class TaBuildingController extends BaseController {

    @Autowired
    ITaBuildingService taBuildingService;

    @Autowired
    ITaSaveService iTaSaveService;

    @Autowired
    ITaPersonService iTaPersonService;

    @Autowired
    TaBuildingMapper taBuildingMapper;

    @Autowired
    TaOrgMapper taOrgMapper;

    @Autowired
    ITaPersonBuildingService taPersonBuildingService;

    @Autowired
    private ISceneLogService iSceneLogService;

    @Autowired
    TaBuildingApartmentMapper taBuildingApartmentMapper;

    @Autowired
    IBkAgreementService iBkAgreementService;

    /**
     * 楼盘详情
     *
     * @param id
     * @return
     */
    @GetMapping("/admin/buildingSelectId/{id}")
    @ApiOperation(value = "项目详情", notes = "项目详情")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "path", name = "id", value = "项目id")
    })
    public ResponseBean buildingSelectId(@PathVariable(value = "id") String id) {
        return taBuildingService.buildingSelectId(id);
    }

    /**
     * 楼盘列表 查询所有有效的
     *
     * @param pageNum
     * @param pageSize
     * @param name
     * @param code
     * @return
     */
    @ApiOperation(value = "项目列表 查询所有有效的", notes = "项目列表 查询所有有效的")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "pageNum", value = "第几页"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "pageSize", value = "一页多少行"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "name", value = "项目名称"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "code", value = "项目编号"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "startDate", value = "开盘时间"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "buildingStatus", value = "项目状态"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "marketStatus", value = "销售状态"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "cityId", value = "城市Id"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "isMain", value = "是否主推项目"),
    })
    @GetMapping("/admin/buildinglist")
    public ResponseBean buildingList(@RequestParam(value = "pageNum", defaultValue = "1") Integer pageNum,
                                     @RequestParam(value = "pageSize", defaultValue = "10") Integer pageSize,
                                     @RequestParam(value = "name", required = false) String name,
                                     @RequestParam(value = "code", required = false) String code,
                                     @RequestParam(value = "startDate", required = false) @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME) LocalDateTime startDate,
                                     @RequestParam(value = "buildingStatus", required = false) String buildingStatus,
                                     @RequestParam(value = "marketStatus", required = false) String marketStatus,
                                     @RequestParam(value = "cityId", required = false) Integer cityId,
                                     @RequestParam(value = "isMain", required = false) Integer isMain,
                                     HttpServletRequest request) {
        return taBuildingService.buildingList(pageNum, pageSize, name, code, startDate, buildingStatus, marketStatus, cityId, isMain, getOrgId(request), getTaPersonBuildingListByUserId(request), getInstitutionIds(request));
    }

    /**
     * 楼盘列表
     *
     * @param pageNum
     * @param pageSize
     * @param name
     * @param code
     * @return
     */
    @ApiOperation(value = "项目列表", notes = "项目列表")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "pageNum", value = "第几页"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "pageSize", value = "一页多少行"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "name", value = "项目名称"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "code", value = "项目编号"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "startDate", value = "开盘时间"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "buildingStatus", value = "项目状态"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "marketStatus", value = "销售状态"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "cityId", value = "城市Id"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "isMain", value = "是否主推项目"),
    })
    @GetMapping("/admin/buildinglist/select")
    public ResponseBean buildingListSelect(@RequestParam(value = "pageNum", defaultValue = "1") Integer pageNum,
                                           @RequestParam(value = "pageSize", defaultValue = "10") Integer pageSize,
                                           @RequestParam(value = "name", required = false) String name,
                                           @RequestParam(value = "code", required = false) String code,
                                           @RequestParam(value = "startDate", required = false) @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME) LocalDateTime startDate,
                                           @RequestParam(value = "buildingStatus", required = false) String buildingStatus,
                                           @RequestParam(value = "marketStatus", required = false) String marketStatus,
                                           @RequestParam(value = "cityId", required = false) Integer cityId,
                                           @RequestParam(value = "isMain", required = false) Integer isMain,
                                           HttpServletRequest request) {
        return taBuildingService.buildingListSelect(pageNum, pageSize, name, code, startDate, buildingStatus, marketStatus, cityId, isMain, getOrgId(request), getTaPersonBuildingListByUserId(request), getInstitutionIds(request));
    }

    /**
     * 更新楼盘
     *
     * @param parameter
     * @return
     */
    @ApiOperation(value = "更新项目", notes = "更新项目")
    @ApiImplicitParams({

    })
    @PutMapping("/admin/building/update")
    public ResponseBean buildingUpdate(@RequestBody String parameter, HttpServletRequest request) {
        ResponseBean responseBean = taBuildingService.buildingUpdate(parameter, getOrgId(request));
        JSONObject object = JSONObject.parseObject(parameter);
        TaBuilding building = object.toJavaObject(TaBuilding.class);
        iSceneLogService.saveLogs(getUserId(request),"building",building.getBuildingId());
        return responseBean;
    }

    /**
     * 获取项目更新日志
     */
    @ApiOperation(value = "获取项目更新日志", notes = "获取项目更新日志")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "pageNum", value = "第几页"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "pageSize", value = "一页多少行"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "buildingId", value = "项目id"),
    })
    @GetMapping("/admin/building/logs")
    public ResponseBean buildingUpdate(@RequestParam(value = "pageNum", defaultValue = "1") Integer pageNum,
                                       @RequestParam(value = "pageSize", defaultValue = "10") Integer pageSize,
                                       @RequestParam(value = "buildingId", required = false) String buildingId, HttpServletRequest request) {
        return iSceneLogService.getBuildingLogs(pageNum,pageSize,buildingId, getTaPersonBuildingListByUserId(request), getInstitutionIds(request));
    }

    /**
     * 楼盘添加
     *
     * @param parameter
     * @return
     */
    @ApiOperation(value = "项目添加", notes = "项目添加")
    @ApiImplicitParams({

    })
    @RequestMapping(value = "/admin/building/add", method = RequestMethod.POST)
    public ResponseBean buildingAdd(@RequestBody String parameter, HttpServletRequest request) {
        ResponseBean responseBean = taBuildingService.buildingAdd(parameter, getOrgId(request), getUserId(request));
        JSONObject object = JSONObject.parseObject(parameter);
        TaBuilding building = object.toJavaObject(TaBuilding.class);
        iSceneLogService.saveLogs(getUserId(request),"building",building.getBuildingId());
        return responseBean;
    }

    /**
     * 楼盘getPersonId(request);
     *
     * @param parameter
     * @return
     */
    @ApiOperation(value = "项目发布", notes = "项目发布")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "body", name = "parameter", value = "status：状态，id：项目id"),
    })
    @RequestMapping(value = "/admin/building/update/status", method = RequestMethod.PUT)
    public ResponseBean buildingUpdateStatus(@RequestBody String parameter, HttpServletRequest request) {
        ResponseBean responseBean = taBuildingService.buildingUpdateStatus(parameter, getOrgId(request));
        JSONObject jsonobject = JSONObject.parseObject(parameter);
        String id = jsonobject.getString("id");
        iSceneLogService.saveLogs(getUserId(request),"building",id);
        return responseBean;
    }

    /**
     * 楼盘删除
     *
     * @param id
     * @param request
     * @return
     */
    @ApiOperation(value = "项目发布", notes = "项目发布")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "path", name = "id", value = "项目id"),
    })
    @RequestMapping(value = "/admin/building/delete/{id}", method = RequestMethod.DELETE)
    public ResponseBean buildingdelete(@PathVariable("id") String id, HttpServletRequest request) {
        ResponseBean buildingdelete = taBuildingService.buildingdelete(id, getOrgId(request));
        iSceneLogService.saveLogs(getUserId(request),"building",id);
        return buildingdelete;
    }

    /**
     * 添加户型
     *
     * @param parameter
     * @param session
     * @return
     */
    @ApiOperation(value = "添加户型", notes = "添加户型")
    @RequestMapping(value = "/admin/buildingApartment/add", method = RequestMethod.POST)
    public ResponseBean buildingApartment(@RequestBody String parameter, HttpSession session,HttpServletRequest request) {
        ResponseBean responseBean = taBuildingService.buildingApartmentAdd(parameter);
        TaBuildingApartment building = JSONObject.parseObject(parameter, TaBuildingApartment.class);
        iSceneLogService.saveLogs(getUserId(request),"apartment",building.getBuildingId());
        return responseBean;
    }

    /**
     * 户型编辑
     *
     * @param parameter
     * @return
     */
    @ApiOperation(value = "户型编辑", notes = "户型编辑")
    @RequestMapping(value = "/admin/buildingApartment/update", method = RequestMethod.PUT)
    public ResponseBean buildingApartmentUpdate(@RequestBody String parameter,HttpServletRequest request) {
        ResponseBean responseBean = taBuildingService.buildingApartmentUpdate(parameter);
        TaBuildingApartment building = JSONObject.parseObject(parameter, TaBuildingApartment.class);
        iSceneLogService.saveLogs(getUserId(request),"apartment",building.getBuildingId());
        return responseBean;
    }

    /**
     * 户型详情
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "户型详情", notes = "户型详情")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "path", name = "id", value = "户型id"),
    })
    @RequestMapping(value = "/admin/buildingApartment/{id}", method = RequestMethod.GET)
    public ResponseBean buildingApartmentSelectId(@PathVariable(value = "id") String id) {
        return taBuildingService.buildingApartmentSelectId(id);
    }

    /**
     * 依据项目ID 查户型
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "依据项目ID 查户型", notes = "依据项目ID 查户型")
    @ApiImplicitParams({
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "path", name = "id", value = "项目ID"),
            @ApiImplicitParam(dataTypeClass = String.class, paramType = "query", name = "apartmentType", value = "类型"),
    })
    @RequestMapping(value = "/admin/buildingApartment/buildingId/{id}", method = RequestMethod.GET)
    public ResponseBean buildingApartmentBuildingId(@PathVariable(value = "id") String id,
                                                    @RequestParam(value = "apartmentType", required = false) String apartmentType) {
        return taBuildingService.buildingApartmentBuildingId(id, apartmentType);
    }

    /**
     * 微信端楼盘列表
     * @param pageNumber
     * @param pageSize
     * @param mine
     * @param cityId
     * @param name
     * @param buildingType
     * @param houseType
     * @param price
     * @param priceType
     * @param area
     * @param buildingArea
     * @param brandId
     * @param orderBy 排序字段, 暂时支持类型  单价 : price-asc, price-desc, 开盘时间 : openingDate-asc, openingDate-desc
     * @param request
     * @return
     */
    @RequestMapping(value = "/wx/building/list", method = RequestMethod.GET)
    public ResponseBean getWxBuildingList(
            @RequestParam(defaultValue = "1") Integer pageNumber,
            @RequestParam(defaultValue = "10") Integer pageSize,
            @RequestParam(defaultValue = "false") Boolean mine,
            @RequestParam(required = false) Integer cityId,
            @RequestParam(required = false) String name,
            @RequestParam(required = false) String buildingType, // 项目类型Id
            @RequestParam(required = false) String houseType, // 户型
            @RequestParam(required = false) String price,   // 价格
            @RequestParam(required = false) String priceType,   // 价格类型
            @RequestParam(required = false) String area,    // 面积
            @RequestParam(required = false) String buildingArea,    // 区域
            @RequestParam(required = false) String brandId,    // 品牌开发商
            @RequestParam(required = false) Boolean isRecentOpening,    // 是否近期开盘
            @RequestParam(required = false) Boolean isCommerce,    // 是否文旅商办
            @RequestParam(required = false) String marketStatus,    // 销售状态
            @RequestParam(required = false) String orderBy,    // 排序字段
//            @RequestParam(required = false) Integer minPrice, // 最低价格
//            @RequestParam(required = false) Integer maxPrice, // 最高价格
//            @RequestParam(required = false) Double minBuildingArea, // 最小面积
//            @RequestParam(required = false) Double maxBuildingArea, // 最大面积
            @RequestParam(required = false) Boolean isBorker,   // 是否开启全民经纪人
            HttpServletRequest request
    ) {
        Integer orgId = getOrgId(request);
        List<String> targets = null;
        if (null != mine && mine) {
            String openid = getOpenId(request);
            List<TaPerson> persons = iTaPersonService.getPersonsByOpenId(openid);
            if (null == persons || persons.size() == 0) {
                return ResponseBean.error("当前账户信息异常, 清除缓存重试", ResponseBean.ERROR_UNAVAILABLE);
            }

            targets = iTaSaveService.getTargesOfPerson(persons.get(0).getPersonId(), CommConstant.FAVOR_PROJECT);
        }

        String[] buildingTypeList = !StringUtils.isEmpty(buildingType) ? buildingType.split(",") : null;
        String[] houseTypeList = !StringUtils.isEmpty(houseType) ? houseType.split(",") : null;
        List<String[]> priceList = getParamListOf(price);
        List<String[]> areaList = getParamListOf(area);

        return taBuildingService.getWxBuildingList(pageNumber,
                pageSize,
                name,
                targets,
                cityId,
                mine,
                houseTypeList,
                buildingTypeList,
                priceList,
                areaList,
                orgId,
                priceType,
                buildingArea,
                brandId,
                isRecentOpening,
                isCommerce,
                marketStatus,
                isBorker,
                orderBy);
    }


    /**
     * 先按照 逗号 拆分, 再按照 横线 拆分
     *
     * @param params
     * @return
     */
    private List<String[]> getParamListOf(String params) {
        List<String[]> paramList = new ArrayList<>();

        if (null == params || "".equals(params.trim())) {
            return paramList;
        }

        String[] paramsArray = params.split(",");
        for (String param : paramsArray) {
            paramList.add(param.split("-"));
        }

        return paramList;
    }


    /**
     * 微信推荐楼盘列表
     *
     * @return
     */
    @RequestMapping(value = "/wx/building/main", method = RequestMethod.GET)
    public ResponseBean getWxMainBuildingList(@RequestParam(value = "cityId", required = false) String cityId, HttpServletRequest request) {
        Integer orgId = getOrgId(request);
        return taBuildingService.getWxMainBuildingList(cityId, orgId);
    }


    /**
     * 我绑定的楼盘
     *
     * @return
     */
    @RequestMapping(value = "/wx/building/mine", method = RequestMethod.GET)
    public ResponseBean getWxMainBuildingList(HttpServletRequest request) {
        Integer orgId = getOrgId(request);
        String personId = getPersonId(request);
        List<TaBuilding> lst = taBuildingService.getBuilidngsOfPerson(orgId, personId);
        return ResponseBean.success(lst);
    }

    /**
     * 删除户型
     *
     * @param id
     * @return
     */
    @RequestMapping(value = "/admin/apartment/deleted/{id}", method = RequestMethod.DELETE)
    public ResponseBean apartmentDeleted(@PathVariable(value = "id") String id,HttpServletRequest request) {
        ResponseBean responseBean = taBuildingService.apartmentDel(id);
        QueryWrapper<TaBuildingApartment> buildingApartmentQueryWrapper = new QueryWrapper<>();
        buildingApartmentQueryWrapper.eq("apartment_id", id);
        TaBuildingApartment buildingApartment = taBuildingApartmentMapper.selectOne(buildingApartmentQueryWrapper);
        iSceneLogService.saveLogs(getUserId(request),"apartment",buildingApartment.getBuildingId());
        return responseBean;
    }

    /**
     * 微信楼盘详情
     *
     * @param id
     * @return
     */
    @RequestMapping(value = "/wx/buildingSelectId/{id}", method = RequestMethod.GET)
    @ReportCustomer(type = "building")
    public ResponseBean wxBuildingSelectId(@PathVariable(value = "id") String id,
                                           @RequestParam(value = "qrCodeId", required = false) String qrCodeId,
                                           @RequestParam(value = "channelId", required = false) String channelId,
                                           @RequestParam(value = "sceneId", required = false) String sceneId,
                                           HttpServletRequest request) {
        String openid = getOpenId(request);
        Integer orgId = getOrgId(request);
        List<TaPerson> persons = iTaPersonService.getPersonsByOpenId(openid);
        if (null == persons || persons.size() == 0) {
            return ResponseBean.error("当前账户信息异常, 清除缓存重试", ResponseBean.ERROR_UNAVAILABLE);
        }
        TaPerson person = persons.get(0);
        return taBuildingService.buildingAllSelectId(id, person, orgId);
    }

    /**
     * 查询当前所有项目
     */
    @RequestMapping(value = "/admin/buildingAll", method = RequestMethod.GET)
    public ResponseBean buildingAll(HttpServletRequest request) {
        ResponseBean taBuilding = taBuildingService.buildingAll(getOrgId(request));
        return taBuilding;
    }

    /**
     * 校验楼盘是否可以添加
     */
    @RequestMapping(value = "/admin/verifyMax", method = RequestMethod.GET)
    public ResponseBean verifyMax(HttpServletRequest request) {
        // 根据orgId查询当前楼盘最大数
        TaOrg taOrg = taOrgMapper.selectById(getOrgId(request));
        QueryWrapper<TaBuilding> taBuildingQuery = new QueryWrapper<>();
        taBuildingQuery.eq("org_id", getOrgId(request));
        taBuildingQuery.gt("status", -1);
        int orgNum = taBuildingMapper.selectCount(taBuildingQuery);
        if (orgNum >= taOrg.getBuildingNum()) {
            return ResponseBean.error("当前系统仅供维护" + taOrg.getBuildingNum() + "个项目，需要维护更多项目，请联系相关管理人员", ResponseBean.ERROR_UNAVAILABLE);
        }
        return ResponseBean.success("成功");
    }

    @ApiOperation(value = "admin - 获取驻场人员信息", notes = "admin - 获取驻场人员信息")
    @GetMapping(value = "/admin/building/marketing")
    public  ResponseBean buildingDynamicFinish(@RequestParam(value = "pageNum",defaultValue = "1")Integer pageNum,
                                               @RequestParam(value = "pageSize",defaultValue = "10")Integer pageSize,
                                               @RequestParam String buildingId) {
        return taBuildingService.getMarketingList(pageNum, pageSize, buildingId);
    }

    @ApiOperation(value = "admin - 解绑驻场人员", notes = "admin - 解绑驻场人员")
    @DeleteMapping(value = "/admin/marketing/{id}")
    public  ResponseBean buildingDynamicFinish(@PathVariable String id,HttpServletRequest request) {
        ResponseBean responseBean = new ResponseBean();
        TaPersonBuilding taPersonBuilding = taPersonBuildingService.getById(id);

        boolean state = taPersonBuildingService.removeById(id);
        if (state) {
            // 查询下是否还有其他的楼盘驻场
            LambdaQueryWrapper<TaPersonBuilding> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(TaPersonBuilding::getPersonId,taPersonBuilding.getPersonId());
            List<TaPersonBuilding> list = taPersonBuildingService.list(lambdaQueryWrapper);
            if (list.size() < 1) {
                TaPerson taPerson = iTaPersonService.getById(taPersonBuilding.getPersonId());
                // 成为驻场顾问并绑定楼盘
                taPerson.setPersonType(CommConstant.PERSON_ESTATE_CUSTOMER);
                iTaPersonService.updateById(taPerson);
                iSceneLogService.saveLogs(getUserId(request),"marketing",taPersonBuilding.getBuildingId());
            }

            responseBean.addSuccess("解绑成功");
        }else {
            responseBean.addError("请检查是否存在驻场人员");
        }
        return responseBean;
    }

    @ApiOperation(value = "admin - 开启全民经纪人", notes = "admin - 开启全民经纪人")
    @PutMapping(value = "/admin/building/{id}/borker")
    public  ResponseBean switchBorker(@ApiParam("楼盘ID") @PathVariable String id,
                                      @ApiParam(value = "是否开启", allowableValues = "true,false") @RequestParam Boolean on,
                                      HttpServletRequest request) throws Exception {
        TaBuilding taBuilding = taBuildingService.getById(id);
        if (taBuilding == null || CommConstant.STATUS_DELETE.equals(taBuilding.getStatus())) {
            return ResponseBean.error("未找到楼盘", ResponseBean.ERROR_ILLEGAL_PARAMS);
        }

        iBkAgreementService.switchByBuilding(id, on);

        taBuilding.setIsBorker(on);
        taBuildingService.updateById(taBuilding);
        return ResponseBean.success("success");
    }

}

