package com.yunzhi.marketing.eContract.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 企业认证表 
 * </p>
 *
 * @author fxf
 * @since 2020-03-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class TaCompany implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 企业id
     */
    @TableId(value = "company_id", type = IdType.AUTO)
    private Integer companyId;

    /**
     * 企业名称
     */
    private String companyName;

    /**
     * 企业编号
     */
    private String companyCode;

    /**
     * 法大大客户编号
     */
    private String fadadaCode;

    /**
     * 认证企业人员的身份 legal法人agent代理人
     */
    private String companyManagerType;

    /**
     * 认证序列号 认证的序列号
     */
    private String certifiedSerialNumber;

    /**
     * 实名认证地址 实名认证地址
     */
    private String certifiedAddress;

    /**
     * 实名认证状态 实名认证状态
     */
    private String certifiedStatus;

    /**
     * 不通过原因
     */
    private String reason;

    /**
     * 审核时间
     */
    private LocalDateTime verifyTime;

    /**
     * 认证方式 认证方式
     */
    private Integer certifiedType;

    /**
     * 创建时间
     */
    private LocalDateTime createDate;

    /**
     * 状态 1有效0无效-1删除
     */
    private Integer status;

    /**
     * 统一社会信用代码
     */
    private String creditCode;

    /**
     * 银行名称
     */
    private String bankName;

    /**
     * 银行帐号
     */
    private String bankAccount;

    /**
     * 开户支行名称
     */
    private String subbranchName;

    /**
     * 姓名
     */
    private String userName;

    /**
     * 手机号
     */
    private String tel;

    /**
     * 身份证号码
     */
    private String idCard;

    /**
     * 自动签章授权状态
     */
    private String authorizeStatus;

    /**
     * 授权类型
     */
    private String authorizeType;

    /**
     * 授权流水号
     */
    private String authorizeTransactionId;

    /**
     * 授权签署地址
     */
    private String authorizeAddress;

    /**
     * 授权合同编号
     */
    private String authorizeContractId;

    /**
     * 自动签章授权结果描述
     */
    private String authorizeDescription;

    /**
     * 授权签署下载地址
     */
    private String authorizeDownloadUrl;

    /**
     * 授权签署查看地址
     */
    private String authorizeViewUrl;

    @TableField(exist = false)
    private Integer sealNum;

    @TableField(exist = false)
    private String contractId;
}
