package com.yunzhi.marketing.xlk.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 楼盘渠道表 
 * </p>
 *
 * @author jobob
 * @since 2021-07-18
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("xlk_building_channel")
public class BuildingChannel implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 楼盘渠道
     */
    @TableId(type = IdType.UUID)
    private String buildingChannelId;

    /**
     * 创建时间
     */
    private LocalDateTime createDate;

    /**
     * 公司id
     */
    private Integer orgId;

    /**
     * 楼盘id
     */
    private String buildingId;

    /**
     * 渠道id
     */
    private String channelId;

    /**
     * 有效期
     */
    private Integer expirationDate;

    /**
     * 备注
     */
    private String remark;


}
