package com.yunzhi.marketing.xlk.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.yunzhi.marketing.entity.TaBuilding;
import com.yunzhi.marketing.xlk.entity.SearchHouse;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 帮我找房 
 * </p>
 *
 * @author jobob
 * @since 2021-05-19
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("xlk_search_house")
public class ExportSearchHouseVO implements Serializable {

    /**
     * 主键
     */
    @TableId(type = IdType.UUID)
    private String id;

    /**
     * 创建人小程序人员
     */
    private String personId;

    /**
     * 创建时间
     */
    @TableField("CREATED_TIME")
    private LocalDateTime createdTime;

    /**
     * 更新人
     */
    @TableField("UPDATED_BY")
    private String updatedBy;

    /**
     * 更新时间
     */
    @TableField("UPDATED_TIME")
    private LocalDateTime updatedTime;

    /**
     * 公司id
     */
    @TableField("ORG_ID")
    private Integer orgId;

    /**
     * 意向区域
     */
    private String intentArea;

    /**
     * 总预算范围最小价格
     */
    private String minPrice;

    /**
     * 总预算范围最大价格
     */
    private String maxPrice;


    /**
     * 0待回访，1已回访，2无效
     */
    private String status;

    /**
     * 审核结果
     */
    private String auditRemark;

    /**
     * 备注
     */
    private String remark;

    /**
     * 问卷json字符串
     */
    private String questionnaire;

    private String avatarurl;

    private String nickname;

    private String phone;

    private String gender;

    private String name;

    /**
     * 房屋现状
     */
    private String houseStatus;

    /**
     * 房屋面积
     */
    private String area;

    /**
     * 家装模式
     */
    private String type;

    /**
     * 家装侧重点
     */
    private String important;
    /**
     * 家装风格
     */
    private String style;
    /**
     * 关键诉求
     */
    private String mostImportant;

    /**
     * 特殊功能区
     */
    private String special;

    /**
     * 是否智能家居
     */
    private String samrt;

    /**
     * 房屋类型
     */
    private String isNew;

    /**
     * 意向居室
     */
    private String layout;

    /***
     * 购房目的
     */
    private String purpose;

    /**
     * 侧重优势
     */
    private String advantage;

    /**
     * 社区要求
     */
    private String facility;

    /**
     * 朝向要求
     */
    private String orientation;

    /**
     * 楼层要求
     */
    private String isHigh;

    /**
     * 楼龄要求
     */
    private String buildingAge;

    /**
     * 租房偏好
     */
    private String preference;


}
